//************************************************************
//Copyright 2016 
//Programmer Neusoft 2016
//2016/11/10 create 
//exercise useing javascript
//************************************************************
/*
 * 打开课程分类列表
 * 
 */
function courseTypeOpen(){
	console.log("function=opencoursetype");
	mui.openWindow({
		id: 'coursetype.html',
		url: 'coursetype.html',
		createNew:false,
		show:{autoShow:true}
	});
}

//根据课程分类打开课程列表
function opencoursetype(id){
	mui.openWindow({
		id: 'courselist.html',
		url: 'courselist.html',
		extras:{coursetypeid:id},
		createNew:false,
		show:{autoShow:true},
	});
}

/*
 * 点击播放课程
 */
function opencourseplay(id,url,name,intro) {
	mui.openWindow({
		id: 'courseplay.html',
		url: 'courseplay.html',					
		extras:{courseid:id,courselogourl:url,coursename:name,courseintro:intro},
		createNew:false,
		show:{autoShow:true}
	});
}

/*
 * 点击播放课程
 */
function openhearingplay(id,url,name,intro) {
	mui.openWindow({
		id: 'hearingplay.html',
		url: 'hearingplay.html',					
		extras:{courseid:id,courselogourl:url,coursename:name,courseintro:intro},
		createNew:false,
		show:{autoShow:true}
	});
}

function openpracticeinfo(id,url,name,intro) {
	mui.openWindow({
		id: 'practiceinfo.html',
		url: 'practiceinfo.html',					
		extras:{courseid:id,courselogourl:url,coursename:name,courseintro:intro},
		createNew:false,
		show:{autoShow:true}
	});
}

/*
 *通过ajax调取最新的课程
 *	coursetypeid 课程分类ID
 * 	topN 最新的N条数据
 * 
 */
function loadcourse(coursetypeid,topN,setlayoutcallback,ispreload){
	//获取课程列表
	console.log("function=loadcourse begin");
	console.log("coursetypeid="+coursetypeid);
	var mytoken=localStorage.getItem(LOCAL_htphToken);
	console.log(mytoken);
	mui.ajax({
		url:serverPath,
		//async: true, 
		type: "post",
		data: {
        	Token:mytoken,
            AjaxType: "CourseTopN",
            topN:topN,
            SubjectId:coursetypeid
        },
        dataType: "json",
		success: function(data) {
		 	var json;
		 	if(ispreload){
		 		//课程选项卡页面，预加载，不进行登录迁移，不进行错误消息提示
		 		json= getdatanoskip(data);
		 	}else{
		 		//课程list画面，进行登录迁移或者错误消息提示
		 		json= getdataforskip(data, 'courselist.html','pullrefresh');
		 	}
		 	if(json == null){ 
		 		return;
		 	}
			setlayoutcallback(json);
            return;
		},
        error: function(xhr, type, errorThrown) {
              mui.toast(breaknet);
              return;
		}
    });
    console.log("function=loadcourse end");
}

/*
 *通过ajax调取最新的课程
 *	coursetypeid 课程分类ID
 * 	topN 最新的N条数据
 * 
 */
function loadcoursebyquestion(coursetypeid,topN,setlayoutcallback,ispreload){
	//获取课程列表
	console.log("function=loadcoursebyquestion begin");
	console.log("coursetypeid="+coursetypeid);
	var mytoken=localStorage.getItem(LOCAL_htphToken);
	console.log(mytoken);
	mui.ajax({
		url:serverPath,
		//async: true, 
		type: "post",
		data: {
        	Token:mytoken,
            AjaxType: "CourseTopNByQuestion",
            topN:topN,
            SubjectId:coursetypeid
        },
        dataType: "json",
		success: function(data) {
		 	var json;
		 	if(ispreload){
		 		//课程选项卡页面，预加载，不进行登录迁移，不进行错误消息提示
		 		json= getdatanoskip(data);
		 	}else{
		 		//课程list画面，进行登录迁移或者错误消息提示
		 		json= getdataforskip(data, 'practice.html','pullrefresh');
		 	}
		 	if(json == null){ 
		 		return;
		 	}
			setlayoutcallback(json);
            return;
		},
        error: function(xhr, type, errorThrown) {
              mui.toast(breaknet);
              return;
		}
    });
    console.log("function=loadcoursebyquestion end");
}
