//************************************************************
//Copyright 2016 
//Programmer Neusoft 2016
//2016/11/10 create 
//index.html useing javascript
//************************************************************
console.log("首页开始启动=====begin");
var menu = null, //侧滑菜单页面
	main = null; //主页面
var showMenu = false;
mui.init();

//自动登陆处理
autoLogin(); //logincommon.js

if(!localStorage.getItem(LOCAL_St_Grade)){ //默认设置为二年级
	localStorage.setItem(LOCAL_St_Grade, 2);
}

//是否显示加载中loading（初次打开APP时不显示加载，利用延迟加载的方式）
var showLoadingFlag = false;

//设定选项卡页面==================================End
var aniShow = {};
//创建子页面，首个选项卡页面显示，其它均隐藏；
mui.plusReady(function() {

	console.log("mui.plusReady begin");

	//导航页面处理================================BEGIN
	//读取本地存储，检查是否为首次启动
	var showGuide = plus.storage.getItem(LOCAL_GUIDE_SHOWFLAG);
	console.log("引导页关键字=", showGuide);

	if(showGuide) {
		//有值，说明已经显示过了，无需显示；
		//关闭splash页面；
		plus.navigator.closeSplashscreen();
		plus.navigator.setFullscreen(false);
		//显示首页Loading
		showLoadingFlag = true;
		//首页处理
		initIndex();
	} else {
		//显示启动导航
		mui.openWindow({
			id: 'guide',
			url: 'guide.html',
			show: {
				aniShow: 'none'
			},
			waiting: {
				autoShow: false
			}
		});
		//延迟的原因：优先打开启动导航页面，避免资源争夺
		setTimeout(function() {
			//首页处理
			initIndex();
		}, 200);
	}
	//导航页面处理================================END	
	console.log("mui.plusReady end");
});

/**
 * 首页处理函数
 */
function initIndex() {
	//设定选项卡页面==================================Begin
	//所有预加载页面都进行加载
	//首页、课程、练习、我的、搜索、资讯
	//前四个页面属于齐头齐尾的子页面
	//后三个页面属于独立页面
	var subpages = ['answer.html', 'practice.html', 'hearingnew.html', 'course.html', 'self.html'];
	var subpage_style = {
		top: '45px',
		bottom: '51px'
	};

	//设置状态条颜色 
	plus.navigator.setStatusBarBackground("#ec5146");
	main = plus.webview.currentWebview();
	var nwaiting;
	if(showLoadingFlag) {
		nwaiting = plus.nativeUI.showWaiting("加载中...");
	}

	var activeIndex = 2; //默认激活页面索引
	//	var temp = {};
	//	console.log("load home.html BEGIN");
	//	var sub = plus.webview.create(subpages[2], subpages[2], subpage_style);
	//	temp[subpages[i]] = "true";
	//	mui.extend(aniShow,temp);
	//	main.append(sub);
	//	console.log("load home.html END");
	nwaiting.close(); //新webview的载入完毕后关闭等待框
	//*************************************************

	//plus.Waiting.SHOW_COMMENT

	//预加载'course.html', 'exercise.html', 'self.html'
	for(var i = 0; i < 5; i++) {
		var temp = {};
		if(i != activeIndex) {
			subpage_style.top = "45px";
		} else {
			subpage_style.top = "0px";
		}
		var sub = plus.webview.create(subpages[i], subpages[i], subpage_style);
		if(i != activeIndex) {
			sub.hide();
		} else {
			temp[subpages[i]] = "true";
			mui.extend(aniShow, temp);
		}
		main.append(sub);
	}

	//仅支持竖屏显示
	plus.screen.lockOrientation("portrait-primary");
	main.addEventListener('maskClick', closeMenu);
	//侧滑菜单的处理===============================Begin
	//处理侧滑导航，为了避免和子页面初始化等竞争资源，延迟加载侧滑页面；
	setTimeout(function() {
		menu = mui.preload({
			id: 'index-menu',
			url: 'index-menu.html',
			styles: {
				left: 0,
				width: '70%',
				zindex: -1
			},
			show: {
				aniShow: 'none'
			}
		});
	}, 200);
	//侧滑菜单的处理===============================End

	//选项卡Javasacript代码处理===================================Begin
	//当前激活选项
	var activeTab = subpages[activeIndex];
	//标题对象
	var title = document.getElementById("title");
	//选项卡点击事件
	mui('.mui-bar-tab').on('tap', 'a', function(e) {
		var targetTab = this.getAttribute('href');
		if(targetTab == activeTab) {
			//如果是当前页面，返回。
			return;
		}
		console.log("click bottom nav:cur->" + targetTab + " act->" + activeTab);

		//更换标题
		title.innerHTML = this.querySelector('.mui-tab-label').innerHTML;
		//显示目标选项卡
		//若为iOS平台或非首次显示，则直接显示
		if(mui.os.ios || aniShow[targetTab]) {
			plus.webview.show(targetTab);
		} else {
			//否则，使用fade-in动画，且保存变量
			var temp = {};
			temp[targetTab] = "true";
			mui.extend(aniShow, temp);
			plus.webview.show(targetTab, "fade-in", 300);
		}
		//隐藏当前;
		plus.webview.hide(activeTab);
		//更改当前活跃的选项卡
		activeTab = targetTab;
	});

}

//选项卡Javasacript代码处理===================================END

//侧滑处理==================================================Begin
//初始化侧滑状态	
var isInTransition = false;
/**
 * 显示侧滑菜单
 */
function openMenu() {
	if(isInTransition) {
		return;
	}
	if(!showMenu) {
		//侧滑菜单处于隐藏状态，则立即显示出来；
		isInTransition = true;
		menu.setStyle({
			mask: 'rgba(0,0,0,0)'
		}); //menu设置透明遮罩防止点击
		menu.show('none', 0, function() {
			//主窗体开始侧滑并显示遮罩
			main.setStyle({
				mask: 'rgba(0,0,0,0.4)',
				left: '70%',
				transition: {
					duration: 150
				}
			});
			mui.later(function() {
				isInTransition = false;
				menu.setStyle({
					mask: "none"
				}); //移除menu的mask
			}, 160);
			showMenu = true;
		});
	}
};
/**
 * 关闭菜单
 */
function closeMenu() {
	if(isInTransition) {
		return;
	}
	if(showMenu) {
		//关闭遮罩；
		//主窗体开始侧滑；
		isInTransition = true;
		main.setStyle({
			mask: 'none',
			left: '0',
			transition: {
				duration: 200
			}
		});
		showMenu = false;
		//等动画结束后，隐藏菜单webview，节省资源；
		mui.later(function() {
			isInTransition = false;
			menu.hide();
		}, 300);
	}
};
//点击左上角侧滑图标，打开侧滑菜单；
document.querySelector('.mui-icon-bars').addEventListener('tap', function(e) {
	if(showMenu) {
		closeMenu();
	} else {
		openMenu();
	}
});

//主界面向右滑动，若菜单未显示，则显示菜单；否则不做任何操作
window.addEventListener("swiperight", openMenu);
//主界面向左滑动，若菜单已显示，则关闭菜单；否则，不做任何操作；
window.addEventListener("swipeleft", closeMenu);
//侧滑菜单触发关闭菜单命令
window.addEventListener("menu:close", closeMenu);
window.addEventListener("menu:open", openMenu);
//重写mui.menu方法，Android版本menu按键按下可自动打开、关闭侧滑菜单；
mui.menu = function() {
	if(showMenu) {
		closeMenu();
	} else {
		openMenu();
	}
}
//首页返回键处理
//1、若侧滑菜单显示，则关闭侧滑菜单
//2、否则，执行mui框架默认的关闭首页功能
var _back = mui.back;
mui.back = function() {
	if(showMenu) {
		closeMenu();
	} else {
		_back();
	}
};
//侧滑处理==================================================END

//点击搜索按钮处理=============================================BEGIN
//处理右上角关于图标的点击事件；
document.getElementById('info').addEventListener('tap', function() {
	//防止多次点击
	if(unsafe_tap()) return;
	mui.openWindow({
		url: "search.html",
		id: "search.html",
		preload: true
	});
});
//点击搜索按钮处理=============================================END