//************************************************************
//Copyright 2016 
//Programmer Neusoft 2016
//2016/11/10 create 
//exercise useing javascript
//************************************************************
function loadexercise(type, id, windowID){
	//获取课程章节练习列表
	console.log("function=loadexercise begin");
	console.log("type=" + type + "  id="+id);
	var studentid = localStorage.getItem(LOCAL_St_ID);
	var token=localStorage.getItem(LOCAL_htphToken);
	var data;
	if(type=='course'){
		data = {
        	Token:token,
            AjaxType: "GetQuestionByCourseID",
            CourseID:id
        };
	}else if(type=='section'){
		data = {
        	Token:token,
            AjaxType: "GetQuestionBySectionID",
            SectionID:id
        };
	}else if(type=='wrong'){
		data = {
        	Token:token,
            AjaxType: "GetStudentQuestion",
            StudentID:studentid
        };
	}else{
		data = {
        	Token:token,
            AjaxType: "GetQuestionByTestPaperID",
            TestPaperID:id
        };
	}
	mui.ajax({
		url:serverPath,
		//async: true, 
		type: "post",
		data: data,
        dataType: "json",
		success: function(data) {
			var json = getdataforskip(data,windowID,'questionbody');
			if(json == null){
				showselfpage();
				return;
			}
			
			if(type=='testpaper'){
			    if(json.length > 0){
			    	for(var i = 1; i<json.length;i++){
			    		json[0] = json[0].concat(json[i]);
			    	}
			    	json = json[0];
			    }
			    
			}
			questionNumber = json.length;
			
			var questiontitle=document.getElementById("questiontitle");
			var questionbody=document.getElementById("questionbody");
//			for(var i = 99; i >= json.length; i--){
//				questiontitle.removeChild(questiontitle.children[i]);
//			}
			questiontitle.className= 'mui-scroll';
			for(var i=0; i<json.length; i++) 
			{   
				console.log(json[i].Qus_Title);
				
				var a = document.createElement('a');
				a.className = 'mui-control-item';
				a.href = '#item'+i;
				var innerHTML='<span class="'+(i==0?'tino':'')+'">' + (i+1) + '</span>';
				a.innerHTML = innerHTML;
				questiontitle.appendChild(a);
				
				//console.log(a.outerHTML);

				questionbody.appendChild(createquestion(json[i], i));
				
				if(i==0){
					var explaintext = json[i].Qus_Explain;
                    explaintext = (explaintext == null || explaintext == "")?'(无解析)':explaintext;
                    var answertext = getquestionanswer(json[i], false);
                    answertext = (answertext == null || answertext == "")?'(无答案)':answertext;
                
					mui('#explainPopover .mui-card-content-inner')[0].innerHTML = explaintext;
					mui('#answerPopover .mui-card-content-inner')[0].innerHTML = answertext;
				}
			}
			mui('#slider').slider().gotoItem(0);
			showselfpage();
		},
        error: function(xhr, type, errorThrown) {
            mui.toast(breaknet);
			showselfpage();
		}
    });
    console.log("function=loadexercise end");
};
function showselfpage(){
	var self = plus.webview.currentWebview();
	self.show('slide-in-right',300);
    plus.nativeUI.closeWaiting();
}

var slideNumber=0;
var questionNumber=0;
var answerlablearray=['A','B','C','D','E','F','G','H'];
var blankquestionflagarray=['(______)','（______）','______','_____','____','___'];
function createquestion(question, i){
	var div = document.createElement('div');
	div.id = 'item'+i;
	div.className = 'mui-slider-item mui-control-content' +(i==0?' mui-active':'');
	
	var wrapperdiv = document.createElement('div');
	wrapperdiv.className='mui-scroll-wrapper';
	var scrolldiv = document.createElement('div');
	scrolldiv.className='mui-scroll';
	
	var innerHTML='<div class="mui-card">';
		innerHTML+='<div class="mui-card-header">'+getquestiontypename(question.Qus_Type)+'</div>';
		innerHTML+='<div class="mui-card-content">';
		innerHTML+='<div class="mui-card-content-inner">';
		innerHTML+=question.Qus_Title;
		innerHTML+='</div>';
		innerHTML+='</div>';
		innerHTML+='</div>';		
        innerHTML+=getquestioncontent(question,i);
        innerHTML+='<input type="hidden" name="answer" value="' + getquestionanswer(question, true) + '"/>';
        innerHTML+='<input type="hidden" name="qusid" value="' + question.Qus_ID + '"/>';
        innerHTML+='<input type="hidden" name="number" value="' + question.Qus_Number + '"/>';
        innerHTML+='<input type="hidden" name="explain" value="' + escape(question.Qus_Explain) + '"/>';
        innerHTML+='<input type="hidden" name="type" value="' + question.Qus_Type + '"/>';
    scrolldiv.innerHTML = innerHTML;
    wrapperdiv.appendChild(scrolldiv);
    mui(wrapperdiv).scroll();
    div.appendChild(wrapperdiv);
    return div;
};

function getquestiontypename(type){
	if(type=='1'){
		return "单选题";
	}else if(type=='2'){
		return "多选题";
	}else if(type=='3'){
		return "判断题";
	}else if(type=='4'){
		return "简答题";
	}else if(type=='5'){
		return "填空题";
	}
};

function getquestioncontent(question,index){
	console.log(question.Qus_Type);
	var html = '';
	if(question.Qus_Type == '1'){
		html='<div class="mui-card">';
		html+='<ul class="mui-table-view mui-table-view-radio">';
		for(var i = 0; i< question.Qus_Items.length;i++){
			html+='<li class="mui-table-view-cell  mui-radio mui-left">';
			//html+='<input name="radio" type="radio" value="'+question.Qus_Items[i].Ans_Context+'">'+question.Qus_Items[i].Ans_Context;
			html+='<input name="radio'+index+'" type="radio" ansid="'+question.Qus_Items[i].Ans_ID+'" value="'+answerlablearray[i]+'">'+answerlablearray[i] + '. ';
			html+=question.Qus_Items[i].Ans_Context;
			html+='</li>';
		}
		html+='</ul></div>';
	}else if(question.Qus_Type == '2'){
		html='<div class="mui-card">';
		html+='<ul class="mui-table-view mui-table-view-radio">';
		for(var i = 0; i< question.Qus_Items.length;i++){
			html+='<li class="mui-table-view-cell  mui-checkbox mui-left">';
			//html+='<input name="checkbox" type="checkbox" value="'+question.Qus_Items[i].Ans_Context+'">'+question.Qus_Items[i].Ans_Context;
			html+='<input name="checkbox'+index+'" type="checkbox" ansid="'+question.Qus_Items[i].Ans_ID+'" value="'+answerlablearray[i]+'">'+answerlablearray[i] + '. </input>';
			html+=question.Qus_Items[i].Ans_Context;
			html+='</li>';
		}
		html+='</ul></div>';
	}else if(question.Qus_Type == '3'){
		html='<div class="mui-card">';
		html+='<ul class="mui-table-view mui-table-view-radio">';
		html+='<li class="mui-table-view-cell mui-radio mui-left">';
		html+='<input name="radio'+index+'" type="radio" ansid="1" value="A">A. 正确';
		html+='</li>';
		html+='<li class="mui-table-view-cell mui-radio mui-left">';
		html+='<input name="radio'+index+'" type="radio" ansid="0" value="B">B. 错误';
		html+='</li>';
		html+='</ul></div>';
	}else if(question.Qus_Type == '4'){
		html='<div class="mui-card" style="padding:5px;">';
		html+='<textarea style="" id="textarea" rows="7" placeholder="请输入简答题答案"></textarea>';
		html+='</div>';
	}else if(question.Qus_Type == '5'){
		html='<div class="mui-card" style="padding:5px;">';
		
		var blankflag = '(______)';
		for(var i = 0;i< blankquestionflagarray.length;i++){
			if(question.Qus_Title.indexOf(blankquestionflagarray[i]) >= 0){
				blankflag = blankquestionflagarray[i];
				break;
			}
		}
		var questionitemarray = question.Qus_Title.split(blankflag);
		for(var i = 0; i< (questionitemarray.length-1);i++){
			html+='<div class="mui-input-row">';
			html+='<input name="text'+index+'" type="text" placeholder="请输入第'+(i+1)+'个空的答案">';
			html+='</div>';
		}
		html+='</div>';					
	}
	
	return html;
};

function getquestionanswer(question,isescape){
	var answer = '';
	var type = question.Qus_Type;
	if(type=='1'){
		for(var i = 0; i< question.Qus_Items.length;i++){
			if(question.Qus_Items[i].Ans_IsCorrect == 'True'){
				answer = answerlablearray[i];
				break;
			}
		}
	}else if(type=='2'){
		for(var i = 0; i< question.Qus_Items.length;i++){
			if(question.Qus_Items[i].Ans_IsCorrect == 'True'){
				if(answer == ''){
					answer= answerlablearray[i];
				}else{
				    answer+= ',' + answerlablearray[i];
				}
			}
		}
	}else if(type=='3'){
		if(question.Qus_IsCorrect == '1'){
			answer = 'A';
		}else{
			answer = 'B';
		}
	}else if(type=='4'){
		if(isescape){
			answer = escape(question.Qus_Answer);
		}else{
			answer = question.Qus_Answer;
		}
		
	}else if(type=='5'){
		for(var i = 0; i< question.Qus_Items.length;i++){
			answer+= question.Qus_Items[i].Ans_Context + '<br/>';
		}
	}
	
	return answer;
};

function getinputanswer(question,index){
	var selectedanswer = '';
	var type = question.querySelector('input[name="type"]').value;
	
	if(type=='1'){
		if(question.querySelectorAll('input[name="radio'+index+'"]:checked').length == 1){
		    selectedanswer = question.querySelectorAll('input[name="radio'+index+'"]:checked')[0].value;
		}
	}else if(type=='2'){
		var selectedanswerobj = question.querySelectorAll('input[name="checkbox'+index+'"]:checked');
		for(var i=0;i < selectedanswerobj.length;i++){
			if(i==0){
				selectedanswer = selectedanswerobj[i].value;
			}else{
			    selectedanswer+= ','+selectedanswerobj[i].value;
			}
		}
	}else if(type=='3'){
		if(question.querySelectorAll('input[name="radio'+index+'"]:checked').length == 1){
		    selectedanswer = question.querySelectorAll('input[name="radio'+index+'"]:checked')[0].value;
		}
	}else if(type=='4'){
		selectedanswer = question.querySelectorAll('textarea')[0].value + '<br />';
	}else if(type=='5'){
		var selectedanswerobj = question.querySelectorAll('input[name="text'+index+'"]');
		for(var i=0;i < selectedanswerobj.length;i++){
			selectedanswer+=selectedanswerobj[i].value + '<br/>';
		}
	}

	return selectedanswer;
};

function calanswernumber(){
	var numberSum = 0;
	for(var i = 0; i < questionNumber; i++){
		var question = document.getElementById("item" +i);
		var selectedanswer = getinputanswer(question, i);
		var answer = unescape(question.querySelector('input[name="answer"]').value);
		var number = parseInt(question.querySelector('input[name="number"]').value);
		//alert(selectedanswer+'/'+answer);
		if(selectedanswer == answer){
			numberSum = numberSum +number;
		}
	}
	
	return numberSum;
};
/**
 * 交卷处理
 * @param {Object} testpaperid
 * @param {Object} testpapername
 * @param {Object} callback
 */
function sendtestanswer(testpaperid, testpapername, callback){
	console.log("function=sendtestanswer begin");
	console.log("testpaperid=" + testpaperid);

	var studentid = localStorage.getItem(LOCAL_St_ID);
	var token = localStorage.getItem(LOCAL_htphToken);
	mui.ajax({
		url:serverPath,
		//async: true, 
		type: "post",
		data: {
			StudentID:studentid,
			TestPaperID:testpaperid,
			IP:'',
			Mac:'',
			Results:JSON.stringify(gettestanswer(testpaperid, testpapername)),
        	Token:token,
            AjaxType: "SetTestResult"
        },
        dataType: "json",
		success: function(data) {
			callback(data);
		 	return;
        },
        error: function(xhr, type, errorThrown) {
            mui.toast(breaknet);
            return null;
		}
    });
    console.log("function=sendtestanswer end");
};

function gettestanswer(testpaperid, testpapername){
	var type = "";
	var ques = new Array();
	var q = new Array();
	var typetotalnumber = 0;
	console.log("questionNumber=" + questionNumber);
	for(var i = 0; i < questionNumber; i++){
		var question = document.getElementById("item" +i);
		var tmptype = question.querySelector('input[name="type"]').value;
		var ans = getinputanswerforsend(question, i);
		
		console.log("tmptype=" + tmptype);
		console.log("ans=" + ans);

		var qusid = question.querySelector('input[name="qusid"]').value;
		var number = question.querySelector('input[name="number"]').value;
		var qitem = {
			"id":qusid,                                 //问题id（*）Qus_ID
			"class":"answer",                           //（固定值*）
			"num":number,                               //该题分数（*）Qus_Number
			"ans":ans,          						//作答答案（*）Ans_ID 多选、填空时逗号分隔
			"sucess":"",          						//回答是否正确（-）
			"score": ""           						//得分（-）
		};
		console.log("qitem=" + JSON.stringify(qitem));
		if(type!= "" && type != tmptype){
			//新建一个que
			var que = {
				    "type":type,                        //题型（*）Qus_Type
				    "count":q.length,                   //题量（*）Qus_Items的数量
				    "number":typetotalnumber,           //成绩（推测,但都是固定值0）（*）Qus_Number的合计值
				    "q":q
			};
			ques.push(que);
			console.log("q.length=" + q.length);
			
			q = new Array();
			q.push(qitem);
			typetotalnumber = parseInt(number);
			type = tmptype;
		}else{
			q.push(qitem);
			console.log("q.length=" + q.length);
			typetotalnumber+= parseInt(number);
			type = tmptype;
		}
		if(i == (questionNumber-1)){
			var que = {
			    "type":type,                        //题型（*）Qus_Type
			    "count":q.length,                   //题量（*）Qus_Items的数量
			    "number":typetotalnumber,           //成绩（推测,但都是固定值0）（*）Qus_Number的合计值
			    "q":q
			};
			ques.push(que);
		}
	}
	
	console.log("ques=" + JSON.stringify(ques));

	var studentid = localStorage.getItem(LOCAL_St_ID);
	var studentname = localStorage.getItem(LOCAL_St_Name);
	var result = {
			"uid":     "",
			"examid":  "0",         //目前都是0，不知道是什么id（-）
			"stid":    studentid,   //学生id（*）
			"stname":  studentname, //学生名（*）
			"sbjid":   "",       //学科ID（-）SubjectId
			"sbjname": testpapername,       //试卷名称（*）Tp_Name
			"patter":  "2",       //推测可能是数据格式标识 目前都是2，可能是代表xml格式（-）
			"tpid":    testpaperid, //试卷id（*）Tp_Id
			"ques":    ques
	};
	
	console.log(JSON.stringify(result));
	
	return result;
}

function getinputanswerforsend(question,index){
	var selectedanswer = '';
	var type = question.querySelector('input[name="type"]').value;
	
	if(type=='1'){
		if(question.querySelectorAll('input[name="radio'+index+'"]:checked').length == 1){
		    selectedanswer = question.querySelectorAll('input[name="radio'+index+'"]:checked')[0].getAttribute("ansid");
		}
	}else if(type=='2'){
		var selectedanswerobj = question.querySelectorAll('input[name="checkbox'+index+'"]:checked');
		for(var i=0;i < selectedanswerobj.length;i++){
			if(i==0){
				selectedanswer = selectedanswerobj[i].getAttribute("ansid");
			}else{
			    selectedanswer+= ','+selectedanswerobj[i].getAttribute("ansid");
			}
		}
	}else if(type=='3'){
		if(question.querySelectorAll('input[name="radio'+index+'"]:checked').length == 1){
		    selectedanswer = question.querySelectorAll('input[name="radio'+index+'"]:checked')[0].getAttribute("ansid");
		}
	}else if(type=='4'){
		selectedanswer = question.querySelectorAll('textarea')[0].value;
	}else if(type=='5'){
		var selectedanswerobj = question.querySelectorAll('input[name="text'+index+'"]');
		for(var i=0;i < selectedanswerobj.length;i++){
			if(i==0){
				selectedanswer+=selectedanswerobj[i].value;
			}else{
			    selectedanswer+= ',' + selectedanswerobj[i].value;
			}
		}
	}

	return selectedanswer;
};

function getMac() {
	var ip = "xxx.xxx.xxx.xxx";
	var mac = "xxx-xxx-xxx-xxx";
	if (plus.os.name == "Android") {
		var Context = plus.android.importClass("android.content.Context");
		var WifiManager = plus.android.importClass("android.net.wifi.WifiManager");
		var wifiManager = plus.android.runtimeMainActivity().getSystemService(Context.WIFI_SERVICE);
		var WifiInfo = plus.android.importClass("android.net.wifi.WifiInfo");
		var wifiInfo = wifiManager.getConnectionInfo();
		mac = wifiInfo.getMacAddress();
		ip = intToIp(wifiInfo.getIpAddress());
		alert(mac + ' /' + ip);
	}
	return {"mac":mac,"ip":ip};
};

function intToIp(INT){
    if(INT < 0 || INT > 0xFFFFFFFF){
        throw ("The number is not normal!");
    }
    //return (INT>>>24) + "." + (INT>>16 & 0xFF) + "." + (INT>>8 & 0xFF) + "." + (INT & 0xFF);
    return (INT & 0xFF) + "." +(INT>>8 & 0xFF) + "." +(INT>>16 & 0xFF) + "." +( INT>>24 & 0xFF) ;
}